# Пакет DBAL
Пакет DBAL (Data Base Abstraction Layer) предоставляет объектно-ориентированный доступ к базе данных, абстрагируясь от деталей конкретной реализации базы данных.

В данный момент пакет DBAL поддерживает следующие базы данных: [MySQL](http://www.mysql.com/) 4.1+, [Oracle](http://www.oracle.com/index.html) (OCI8), [PostgreSQL](http://www.postgresql.org/) 8.2+,

Некоторые задают нам вопрос по поводу того, почему мы не используем PHP-расширение PDO?

* Во-первых, PDO не предоставляет средств для получения meta-информации о структуре базы данных, а эта возможность активно у нас используется в пакете ACTIVE_RECORD.
* Ну, а во-вторых, текущее состояние PDO драйвера оставляет желать лучшего: не поддерживаются многие драйвера, нативные драйвера зачастую работают быстрее и предоставляют большие возможности по контролю работы с БД.

## Использование пакета DBAL
* [Введение в пакет DBAL](./dbal/intro.md)
* [Подключение к базе данных](./dbal/connection.md)
* [Использование классов из подсистем Query и Criteria](./dbal/intro_to_query_and_criteria.md)
* [Поддержка транзакций](./dbal/transactions.md)
* [Загрузка sql-дампа базы данных](./dbal/dump_load.md)

## Архитектура пакета DBAL
Пакет DBAL зависит от следующих пакетов: CORE, TOOLKIT, CONFIG.

Пакет DBAL состоит из нескольких групп классов или подсистем:

Группа классов | Назначение
---------------|-----------
[Driver](./dbal/driver.md) | Драйвер (Driver) — базовые классы для работы с базами данных, которые абстрагируют доступ к базе данных. При помощи них осуществляются операции выборки и изменения состояния базы данных (select, update, insert, delete и т.д.).
[Query](./dbal/query.md)	| Группа классов, позволяющих тем или иным образом инкапсулировать SQL запросы.
[Criteria](./dbal/criteria.md) | Группа классов, позволяющих строить условия для инкапсулированных SQL запросов.
Dump | Группа классов, используемых для загрузки sql-дампов. см. [Загрузка sql-дампов](./dbal/dump_load.md).

Также есть набор дополнительных классов:

Группа классов | Назначение
---------------|-----------
[lmbDBAL](./dbal/lmbdbal.md) | Фасад для DBAL-пакета.
[lmbTableGateway](./dbal/lmb_table_gateway.md) |	Класс, упрощающий работу с отдельными таблицами базы данных.
[lmbSimpleDb](./dbal/lmb_simple_db.md)	| Небольшой фасад для пакета. Позволяет выполнять простейшие CRUD запросы. Используется в основном с тестах
[lmbDbTools](./dbal/lmb_db_tools.md) | Tools для работы с базой данных. Автоматически добавляется в lmbToolkit при включении файла limb/dbal/common.inc.php
lmbDbDump	| Небольшой фасад для Dump-подсистемы пакета. Позволяет загружать sql-дамп и очищать таблицы, затронутые этим дампом. см. [Загрузка sql-дампов](./dbal/dump_load.md).
lmbAutoTransactionFilter | Фильтр, который вставляется в общую цепочку фильтров приложения, и который автоматически стартует транзакцию базы данных при первом запроса на изменение состояния базы данных. см. [Поддержка транзакций](./dbal/transactions.md).
lmbDbException | Класс исключения, которые могут быть сгенерированы классами пакета DBAL.
