# Тег {{list:glue}}
## Описание
Выводит кусок кода, который используется для разделения элементов списка друг от друга. Не выводится после последней записи. Рекомендуется ставить непосредственно перед закрывающим тегом [{{list:item}}](./list_item_tag.md)

см. также раздел [Вывод списков](../../list_tags.md)

## Синтаксис

    {{list:glue [step='number']}}
    ..some content
    {{/list:glue}}

Для тега также есть алиас **{{list:separator}}**

## Область применения
Внутри тега [{{list:item}}](./list_item_tag.md).

## Атрибуты
**step** или **every** (опционально) — позволяет задать шаг, с который должен выводиться разделитель. Позволяет, например, огранизовать вывод данных с колонки по нескольку элементов. По-умолчанию равен 1.

## Содержимое
Любое.

## Пример использования
* см. также тег [{{list:fill}}](./list_fill_tag.md) для генерации валидной верстки при выводе мультиколоночных данных с некратным некоторому числу количеством элементов в списках.

### Один разделитель

    {{list using='$items'}}
    <table>
    <tr>
     {{list:item}}<td>{$item.title}</td>
       {{list:glue step="3"}}</tr><tr>{{/list:glue}}
     {{/list:item}}
    </tr>
    </table>
    {{/list}}

### Несколько разделителей
Можно использовать несколько тегов [{{list:glue}}](./list_glue_tag.md) в рамках одного списка.

Например, вам нужно вывести такой список:

    1 | 2 | 3
    ---------
    4 | 5 | 6
    
Для этого можно использовать следующую конструкцию:

    {{list using='$items'}}
     {{list:item}}
       {$item.number}
       {{list:glue step="3"}}<br/>-----------------<br/>{{/list:glue}}
       {{list:glue}}&nbsp;|&nbsp;{{/list:glue}}
     {{/list:item}}
    {{/list}}

Обратите внимание, что **разделитель с меньшим шагом должен стоять в шаблоне ниже разделителя с большим шагом**. Таким образом можно использовать и более 2-х разделителей.
